lg, lk, lm, ltp, la, lfs, ls, li, lt = love.graphics, love.keyboard, love.mouse, love.touchpressed, love.audio, love.filesystem, love.system, love.image, love.timer

math.randomseed(os.time());math.random();math.random();math.random()

require 'functions'

local hit = 'nope'
local draw_boundings = true

local img = lg.newImage('color-wheel.jpg')

local player = {x=0, y=0}

function love.load()
  lg.setBackgroundColor(50, 50, 50)
  add_col(img, {255, 255, 0}, 2) -- Args: the loaded img, the color {red, green, blue, alpha}, the steps: if less steps then more accurate the bounding but needs more process power
end

function love.update(dt)
  local dx, dy = 0, 0
  local collided = false
  
  if lk.isDown('up') then
    dy = -50*dt
  end
  if lk.isDown('down') then
    dy = 50*dt
  end
  if lk.isDown('left') then
    dx = -50*dt
  end
  if lk.isDown('right') then
    dx = 50*dt
  end
  
  local oldx, oldy = player.x, player.y
  
  player.x = player.x + dx
  player.y = player.y + dy
  
  for i=1, #col do
    if CheckCollision(player.x, player.y, 32, 32, col[i].x, col[i].y, 1, 1) then
      hit = 'Colliding'
      collided = true
      dx, dy = 0, 0
      break
    else
      hit = 'Not colliding'
    end
  end
  
  if collided then
    player.x = oldx
    player.y = oldy
  end
  
end

function love.draw()
  --lg.draw(img, 100, 100, 0, .5, .5)
  lg.setColor(0, 255, 0)
  if draw_boundings then
    for k, v in ipairs(col) do
      lg.points(v.x, v.y)
    end
  end
  lg.setColor(255, 255, 255)
  lg.rectangle('line', player.x, player.y, 32, 32)
  lg.print(hit, 0, 20)
  lg.print('FPS: '..lt.getFPS())
  lg.printf("Press U to toggle pixel collision bounding view", lg.getWidth()-150, 0, 150)
end

function love.keypressed(k)
  if k == 'u' then
    draw_boundings = not(draw_boundings)
  end
end